
****************************
* Roboter Steuerprogramm   *
* von Rolf-Dieter Klein    *
* Version 1.0  830724      *
* konvertiert fr 680xx    *
* von Jens Mewes 20090817  *
****************************

start:
	bra main	; Hauptprogramm

* IO-Port Definitionen

cpu	equ	1

adport	equ	$ffffff30*cpu
tast	equ	$ffffff31*cpu
motor	equ	$ffffff30*cpu

* adport Belegung
* 7    6    5    4    3    2    1    0
* pot2 pot1                     sto  run
*
* tast
* mot2 mot2 mot1 mot1           magn magn
*
* motor
* ein2 pol2 ein1 pol1                einmagn 
*


getad2:		* holt ad-wert von dem Port fuer mot2
		* d0=ergebnis
		* ____----____----  Flanke steigend

	moveq #6, d7
	bra.s get0

getad1:		* holt ad-wert von dem Port fuer mot1
		* d0=ergebnis
		* ____----____----  Flanke steigend	

	moveq #7, d7

get0:	
	lea adport, a0
	clr.l d0
get1:
	btst.b d7, (a0)
	bne.s get1
get2:
	btst.b d7, (a0)
	beq.s get2
get3:
	addq.l #1, d0
	btst.b d7, (a0)
	bne.s get3
	rts


delaus:			* ca 50ms bei GDP-FPGA, sonst 60ms
	move #!sync, d7
	trap #1
	beq.s delaus

delein:			* ca 33,3ms bei GDP-FPGA, sonst 40ms
	move #!sync, d7
	trap #1
	beq.s delein
del1ein:
	move #!sync, d7
	trap #1
	beq.s del1ein
	rts


main:
	move.b #0, motor
	clr magnet
	lea heap(pc), a1
	clr pointer
	move #0, 0(a1)
loop:
	clr.l d2
	move.b tast, d1
	btst.b #7, d1		* mot2 VW
	bne.s sta1
	bset.b #7, d2		* mot2 ein
sta1:
	btst.b #6, d1		* mot2 RW
	bne.s sta2
	bset.b #7, d2
	bset.b #6, d2
sta2:
	btst.b #5, d1		* mot1 VW
	bne.s sta3
	bset.b #5, d2
sta3:
	btst.b #4, d1		* mot1 RW
	bne.s sta4
	bset.b #5, d2
	bset.b #4, d2
sta4:
	btst.b #1, d1		* magnet ein
	bne.s sta5
	move #1, magnet
sta5:
	btst.b #0, d1		* magnet aus
	bne.s sta6
	clr magnet
sta6:
	btst.b #1, adport	* sto
	bne.s sta7
stalp:
	moveq #1, d0
	move #!delay, d7
	trap #1			* entprellung
	btst.b #1, adport
	beq.s stalp		* warten bis losgelassen
	moveq #1, d0
	move #!delay, d7
	trap #1			* entprellung
	bsr getad1
	move pointer, d3
	move d0, 0(d3, a1)
	addq #2, d3
	bsr getad2
	move d0, 0(d3, a1)
	addq #2, d3
	move magnet, 0(d3, a1)
	addq #2, d3
	move d3, pointer
	move #0, 0(d3, a1)
	move #!csts, d7
	trap #1
	beq loop
	rts
	
sta7:
	btst.b #0, adport	* run
	bne sta8
	lea heap(pc), a1
sta7lp:
	move (a1)+, d3		* motor1
	beq loop		* 0 = ende
	move (a1)+, d4		* motor2
	move (a1)+, d5		* magnet

* d3=motor1  d4=motor2

* motor 1 anfahren

	bsr getad1		* aktuelle position
	sub d3, d0
	bpl.s mot1neg		* aktuell > soll dann RW

mot1pos:
	bsr getad1
	sub d3, d0
	neg d0
	cmp #$18, d0
	bls.s slowpos
	move.b d5, d0		* magnet
	or.b #%00100000, d0
	move.b d0, motor
	bra.s mot1pos

slowpos:
	move.b d5, d0		* magnet
	move d0, motor		* motor aus
	bsr delaus
	bsr getad1
	sub d3, d0
	bmi mot1fin
	move.b d5, d0
	or.b #%00100000, d0
	move.b d0, motor
	bsr delein
	bra.s slowpos

mot1neg:
	bsr getad1
	sub d3, d0
	cmp #$18, d0
	bls.s slow1pos
	move.b d5, d0		* magnet
	or.b #%00110000, d0
	move.b d0, motor
	bra.s mot1neg

slow1pos:
	move.b d5, d0		* magnet
	or.b #%00010000, d0	* relais anlassen
	move d0, motor		* motor aus
	bsr delaus
	bsr getad1
	sub d3, d0
	bmi mot1fin
	move.b d5, d0
	or.b #%00110000, d0
	move.b d0, motor
	bsr delein
	bra.s slow1pos

mot1fin:
	bsr getad2		* aktuelle position
	sub d4, d0
	bpl.s mot2neg		* aktuell > soll dann RW

mot2pos:
	bsr getad2
	sub d4, d0
	neg d0
	cmp #$18, d0
	bls.s slow2pos
	move.b d5, d0		* magnet
	or.b #%10000000, d0
	move.b d0, motor
	bra.s mot2pos

slow2pos:
	move.b d5, d0		* magnet
	move d0, motor		* motor aus
	bsr delaus
	bsr getad2
	sub d4, d0
	bmi mot1fin
	move.b d5, d0
	or.b #%10000000, d0
	move.b d0, motor
	bsr delein
	bra.s slow2pos

mot2neg:
	bsr getad2
	sub d4, d0
	cmp #$18, d0
	bls.s slow3pos
	move.b d5, d0		* magnet
	or.b #%11000000, d0
	move.b d0, motor
	bra.s mot2neg

slow3pos:
	move.b d5, d0		* magnet
	or.b #%01000000, d0	* relais anlassen
	move d0, motor		* motor aus
	bsr delaus
	bsr getad1
	sub d4, d0
	bmi mot2fin
	move.b d5, d0
	or.b #%11000000, d0
	move.b d0, motor
	bsr delein
	bra.s slow3pos

mot2fin:			* ende abschalten motore
	move.b d5, motor
	bra sta7lp		* Hauptschleife
	
sta8:
	move magnet, d0
	and #$1, d0
	or.b d1, d0
	move.b d0, motor
	bra loop
	

magnet:		ds.w 1		* magnet flag 0=aus
pointer: 	ds.w 1		* naechster freier Platz
heap:		ds.w 500	* Punktespeicher
				* mot1.w  mot2.w magnet.b
				* 0=ende zeichen
